import numpy as np
import torch
import matplotlib.pyplot as plt
import torch.nn as nn
import torch.nn.functional as F
import time
import math 
plt.ion()

# GD (gradient descent) je jeden z nejdulezitejsich konceptu hlubokeho uceni

# zakladni kroky uceni modelu:
# 1. uhadni reseni (forward)
# 2. vypocitej chybu tohoto reseni (predict vs. real)
# 3. Uc se z chyb a modifikuj parametry aby v dalsi iteraci bylo reseni lepsi (backprop)

# potrebujeme matematicky popis chyby - muzeme ji reprezentovat jako matematickou funkci ("error landscape") a pote potrebujeme najit minimum teto funkce

# Jak najit minum funkce? 
# Pomuze nam derivace v 1D pripade
# Pokud mame vice dimenzi tak se bavime o gradientu, ale koncept je podobny

# pojdme se podivat na jednuduchy 1D priklad a nalezeni minima funkce pomoci GD

def fx(x):
    return x**2 - 6*x + 1
    
def deriv(x):
    return 2*x - 6 
    
x = np.linspace(-14, 20, 2000)
print(x)

localmin = 15.0 #np.random.choice(x,1)
print("localmin", localmin)

plt.plot(x, fx(x))
plt.plot(localmin, fx(localmin), 'ro')
plt.show()
plt.pause(5)


learning_rate = 0.1 #1.0 #0.01
training_epochs = 50

for i in range(training_epochs):
    print("---------------- epoch", i)
    grad = deriv(localmin)
    move = learning_rate * grad
    localmin = localmin - move
    print("grad", grad)
    print("localmin new", localmin)   
    print("localmin fx", fx(localmin))
    plt.plot(localmin, fx(localmin), 'go')
    plt.show()
    plt.pause(5.0)
print(localmin)  

plt.savefig("out.png")


# https://discuss.pytorch.org/t/how-will-sgd-work-under-batch-data/167252/2
